<?php
/*
Plugin Name: AjaxChat
Plugin URI: http://paydensutherland.com
Description: This plugin provides instant messaging between two or more parties viewing your blog.
Version: 0.4.5
Author: Payden Sutherland
Author URI: http://paydensutherland.com
License: GPL2


  Copyright 2010  Payden Sutherland  (email: payden@paydensutherland.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
ob_start(); //output buffering to buffer any headers
date_default_timezone_set('America/New_York');
define('AJAXCHAT_VERSION','0.4.5');
define('AJAXCHAT_PATH',dirname(__FILE__));
require_once('ajaxchat_options.php');
register_activation_hook(__FILE__,'activate_me');
register_deactivation_hook(__FILE__,'deactivate_me');
add_action('init','ajaxchat_script');
add_action('wp_print_styles','ajaxchat_style');
add_action('wp_login','ajaxchat_wp_login');
add_filter('wp_print_footer_scripts','ajaxim_footer');

global $wpdb;
if(!function_exists('ajaxchat_style')) {
	function ajaxchat_style() {
		wp_register_style('ajaxchat_style',plugins_url('/ajaxchat.css.php',__FILE__));
		wp_enqueue_style('ajaxchat_style');
	}
}
if(!function_exists('ajaxchat_script')) {
	function ajaxchat_script() {
		wp_register_script('ajaxchat_script',plugins_url('ajaxchat.js.php',__FILE__));
		wp_register_script('jquery-ui','https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.15/jquery-ui.min.js',array('jquery'));
		wp_enqueue_script('ajaxchat_script');
		wp_enqueue_script('jquery-ui');
	}
}
if(!function_exists('ajaxchat_wp_login')) {
	function ajaxchat_wp_login($user_name) {
		if(!session_id()) { session_start(); }
		global $wpdb;
		$rows=$wpdb->get_results("SELECT name FROM ajaxim_sess WHERE sessid='".session_id()."'");
		if($rows) { $wpdb->query("UPDATE ajaxim_sess SET name='".$user_name."' WHERE sessid='".session_id()."'"); $_SESSION['myName']=$user_name; }
	}
}
if(!function_exists('ajaxim_footer')) {
	function ajaxim_footer() {
		$user=get_currentuserinfo();
		if(preg_match('/^\/wp-admin\//',$_SERVER['PHP_SELF']) || preg_match('/^\/wp-login/',$_SERVER['PHP_SELF'])) { die(); }
		echo "<div id='ajaxIM'>\n";
		echo "<div style='float:left;font-weight:bold;'>AjaxChat v".get_option('ajaxchat_version')."</div>\n";
		echo "<div style='float:right;font-weight:bold;'><a href='javascript:void(0);' onclick='openOnline();'>Chat&nbsp;(<span id='online_count'></span>)</a></div>\n";
		echo "</div>\n";
		//Do main ajaxchat window
		?>
		<div id='ac_window' style='display:none;'>
			<table id='ac_window_table' align='center' width='100%' cellpadding='3' cellspacing='1' style='background-color:#000;border-collapse:separate;''>
			<tr id='ac_window_title' class='tableheader'>
				<td colspan='2'><div><div style='display:inline-table;float:left;'><a href='javascript:void(0);' onclick='popToggle();'>Pop in/out</a></div><div style='display:inline-table;'>AjaxChat v<?=get_option('ajaxchat_version');?></div><div style='display:inline-table;float:right;'><a href='javascript:void(0);' onclick='openOnline();'>X</a></div></td>
			</tr>
			<tr class='tabledata'>
				<td><input type='text' id='myName' onkeypress='im_kp(this,event);' style='width:200px;'>&nbsp;<input type='button' value='Edit Name' onclick='updateName(document.getElementById("myName"));'/></td><td rowspan='2' style='width:25%;text-align:center;vertical-align:top;'><strong>Online</strong><div id='online_list'></div></td>
			</tr>
			<tr class='tabledata'>
				<td>
					<div id='messages'>
					<?php
						if(!session_id()) { @session_start(); }
						$_SESSION['lastmsg']=0;
						include(AJAXCHAT_PATH.'/ajaxchat_ping.php');
					?>
					</div>
				</td>
			</tr>
			<tr class='tabledata'>
				<td colspan='2'><input type='text' id='msg' style='width:99%;' onkeypress='msg_kp(this,event);'/></td>
			</tr>
			</table>
		</div>
		<?php
	}
}
if(!function_exists('activate_me')) {
	function activate_me() {
		global $wpdb;
		if(get_option('ajaxchat_version')=='') { add_option('ajaxchat_version',AJAXCHAT_VERSION); }
		else {
			if(get_option('ajaxchat_version')!=AJAXCHAT_VERSION) { update_option('ajaxchat_version',AJAXCHAT_VERSION); $upgrade=true; }
		}
		if(get_option('ajaxchat_bottom_color')=='') { add_option('ajaxchat_bottom_color','#c0c0c0'); }
		if(get_option('ajaxchat_header_color')=='') { add_option('ajaxchat_header_color','#2a4480'); }
		require_once(ABSPATH.'/wp-admin/includes/upgrade.php');
		if(($wpdb->get_var("SHOW TABLES LIKE 'ajaxim_sess'") != "ajaxim_sess") || ($wpdb->get_var("SHOW TABLES LIKE 'ajaxim_data'")!="ajaxim_data")) {
			$sql = "CREATE TABLE  ajaxim_sess (
				name VARCHAR(256) NOT NULL,
				lasttime BIGINT NOT NULL,
				starttime BIGINT NOT NULL,
				sessid VARCHAR(128) NOT NULL PRIMARY KEY
				);";
			dbDelta($sql);
			$sql = "CREATE TABLE ajaxim_data (
				name VARCHAR(256) NOT NULL,
				time BIGINT NOT NULL,
				msg VARCHAR(1024) NOT NULL,
				msgid INT NOT NULL AUTO_INCREMENT,
				PRIMARY KEY (msgid)
				);";
			dbDelta($sql);
		}
		return true;
	}
}
if(!function_exists('deactivate_me')) {
	function deactivate_me() {
		//nothing yet.
	}
}
?>
